#version 330

// Input
in vec2 fragTexCoord;
in vec4 fragColor;

// Input
uniform sampler2D texture0;
uniform vec4 colDiffuse;
uniform float aspect;
uniform float mosaic_size;

// Output
out vec4 finalColor;

void main() {
    // fragTexCoord is normalized to 0-1
    vec2 uv = fragTexCoord;

    // Aspect ratio correction; gives us square pixels.
    // Without this, width and height will be divided into same
    // number of squares.
    //
    if(aspect > 1.0) uv.x -= mod(uv.x, mosaic_size / aspect);
    else             uv.x -= mod(uv.x, mosaic_size);

    if(aspect < 1.0) uv.y -= mod(uv.y, mosaic_size * aspect);
    else             uv.y -= mod(uv.y, mosaic_size);

    finalColor = texture(texture0, uv) * colDiffuse * fragColor;
}